package body Error_Ops is


   function Sup(E: Error) return Rep is
   begin
      return Rep(E);
   end;


   function Err(R: Radius) return Error is
   begin
      return Error(R);
   end Err;


   function NormSucc(R: Rep) return Error is
   begin
      --  return Error(Succ(Abs(R)));
      return Error(Abs(R));
   end NormSucc;


   function "+"(Left,Right: Error) return Error is
   begin
      --  return Error(Succ(Rep(Left)+Rep(Right)));
      return Error(Rep(Left)+Rep(Right));
   end "+";


   function "*"(R: Rep; E: Error) return Error is
   begin
      --    return Error(Succ(Abs(R)*Rep(E)));
      return Error(Abs(R)*Rep(E));
   end "*";


   function "*"(Left,Right: Error) return Error is
   begin
      --  return Error(Succ(Rep(Left)*Rep(Right)));
      return Error(Rep(Left)*Rep(Right));
   end "*";


   function "**"(E1: Error; I: Natural) return Error is
      J: Integer;
      E,E2: Error;
   begin
      if I=0 then
         return Error(One);
      else
         J := I;
         E := E1;
         if (J rem 2)=0 then
            E2 := Error(One);
         else
            E2 := E;
         end if;
         J := J/2;
         while J>0 loop
            E := E*E;
            if (J rem 2)>0 then
               E2 := E*E2;
            end if;
            J := J/2;
         end loop;
         return E2;
      end if;
   end "**";


   function "/"(E: Error; R: Rep) return Error is
   begin
      --  return Error(Succ(Rep(E)/Abs(R)));
      return Error(Rep(E)/Abs(R));
   end "/";


   function "/"(E: Error; I: Integer) return Error is
   begin
      --  return Error(Succ(Rep(E)/Rep(Abs(I))));
      return Error(Rep(E)/Rep(Abs(I)));
   end "/";


   function Max(E1: Error; E2: Error) return Error is
   begin
      if E1 > E2 then return E1;
      else return E2;
      end if;
   end Max;


end Error_Ops;

