package body Messages is

   procedure Message(Where: in String; What: in Problem) is
   begin
      case What is

         when Division_By_Zero =>
            Put(Where);
            Put(": Division_By_Zero");
            New_Line;
            raise Leaving;

         when Reading_Error =>
            Put(Where);
            Put(": Reading_Error");
            New_Line;
            raise Leaving;

         when Index_Error =>
            Put(Where);
            Put(": Index_Error");
            New_Line;
            raise Leaving;

         when Parity_Error =>
            Put(Where);
            Put(": Parity_Error");
            New_Line;
            raise Constraint_Error;

         when Parameter_Error =>
            Put(Where);
            Put(": Parameter_Error");
            New_Line;
            raise Constraint_Error;

         when Domain_Error =>
            Put(Where);
            Put(": Domain_Violation");
            New_Line;
            raise Constraint_Error;

         when Domain_Violation =>
            Put(Where);
            Put(": Domain_Violation");
            New_Line;

         when Numeric_Only =>
            Put(Where);
            Put(": Numeric_Only");
            New_Line;

         when Not_Implemented =>
            Put(Where);
            Put(": Not_Implemented");
            New_Line;

         when Giving_Up =>
            Put(Where);
            Put(": Giving_Up");
            New_Line;
            raise Leaving;

      end case;


   end Message;

end Messages;













